package de.mlessmann.certassist.openssl;

import lombok.Builder;
import lombok.Getter;
import lombok.Setter;

import java.util.UUID;


@Builder
public class CertificateRequest {

    @Getter
    @Setter
    @Builder.Default
    private String oid = UUID.randomUUID().toString();

    @Getter
    @Setter
    private RequestType type;

    @Getter
    @Setter
    private String commonName;

    @Getter
    @Setter
    private String trustingAuthority;

    @Getter
    @Setter
    @Builder.Default
    private int requestedKeyLength = 4096;

    @Getter
    @Setter
    @Builder.Default
    private int requestedValidityDays = 365;

    @Getter
    @Setter
    @Builder.Default
    private CertificateSubject subject = CertificateSubject.builder().build();

    public enum RequestType {
        ROOT_AUTHORITY,
        STANDALONE_CERTIFICATE,
        NORMAL_CERTIFICATE
    }
}
